<template>
  <div id="app">
    <Navbar/>
    <div class="fixed top-10 right-10 z-50">
      <div class="grid" v-for="(alert, key) in alerts" :key="key">
        <AlertBanner
            :color="alert.color"
            :text="alert.text"
            :icon="alert.icon"
        />
      </div>
    </div>
    <router-view></router-view>
  </div>
</template>

<script>
import AlertBanner from "./components/Form/AlertBanner"
import Navbar from "./components/Navbar"

export default {
  name: 'App',
  components: {
    Navbar,
    AlertBanner
  },
  data() {
    return {
      user: null,
      alerts: []
    }
  },
  beforeMount() {
    this.user = JSON.parse(localStorage.getItem('user'))
  },
  provide() {
    const provider = {
      createAlert: (alert) => {
        this.alerts.push(alert)

        setTimeout(() => {
          this.alerts.splice(0, 1)
        }, 10000)
      },
      addLoginInfo: (token, user) => {
        this.user = user
        this.user.token = token
        localStorage.setItem('user', JSON.stringify(user))
        this.$router.push('/')
      },
      disconnection: () => {
        localStorage.removeItem('user')
        window.location.reload()
      }
    }
    Object.defineProperty(provider, 'user', {
      enumerable: true,
      get: () => this.user,
    })
    return provider
  }
}
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}
</style>
